CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

set(HHVM_DEFINITIONS "HAVE_LIBDL;HAVE_CURL_MULTI_WAIT;U_USING_ICU_NAMESPACE=1;USE_JEMALLOC=1;NO_TCMALLOC=1;OPENSSL_NO_RAND_EGD;USE_EDITLINE;HHVM;HAVE_FT2BUILD;THRIFT_MUTEX_EMULATE_PTHREAD_TIMEDLOCK;HHVM_DYNAMIC_EXTENSION_DIR=\"@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/lib/hhvm/extensions\";_REENTRANT=1;_PTHREADS=1;__STDC_FORMAT_MACROS;NDEBUG;SKIP_USER_CHANGE=1;MAC_OS_X_VERSION_MIN_REQUIRED=MAC_OS_X_VERSION_10_6;MACOSX_DEPLOYMENT_TARGET=10.6;ENABLE_FASTCGI=1;NO_HARDWARE_COUNTERS=1;HPHP_OSS=1;PACKAGE=hhvm;PACKAGE_VERSION=Release;DEFAULT_CONFIG_DIR=\"@@HOMEBREW_PREFIX@@/etc/hhvm\";HAVE_INTTYPES_H;HAVE_SYSTEM_TZDATA;USE_CMAKE;PHP_MYSQL_UNIX_SOCK_ADDR=\"/tmp/mysql.sock\";HAVE_LIBBZIP2;HAVE_LIBCURL;HAVE_LIBXML2;HAVE_LIBICU;HAVE_LIBFRIBIDI;HAVE_LIBGLIB;HAVE_LIBFREETYPE;HAVE_GD_FREETYPE;ENABLE_GD_TTF;HAVE_LIBJPEG;HAVE_GD_JPG;HAVE_ICONV;HAVE_LIBICONV;HAVE_LIBPNG;HAVE_GD_PNG;PNG_SKIP_SETJMP_CHECK;HAVE_LIBINTL;HAVE_LIBGMP;HAVE_LIBMAGICKWAND;HAVE_LIBLDAP;HAVE_LIBMCRYPT;HAVE_LIBMEMCACHED;HAVE_LIBEXPAT;HAVE_LIBXSLT")
set(HHVM_VERSION_BRANCH "48968")
set(CMAKE_INSTALL_PREFIX "@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0")
set(CMAKE_INSTALL_LIBDIR "lib")
set(CMAKE_BUILD_TYPE "RelWithDebInfo")

option(HHVM_DSO_TEST_MODE "Build against source headers, not installed ones" Off)
if (HHVM_DSO_TEST_MODE)
  set(HHVM_INCLUDE_DIRS "/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0;/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk/usr/include;@@HOMEBREW_PREFIX@@/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/sqlite/include;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/tbb@2020/include;@@HOMEBREW_PREFIX@@/opt/openssl@1.1/include;@@HOMEBREW_CELLAR@@/dwarfutils/0.4.0/include/libdwarf-0;@@HOMEBREW_CELLAR@@/libelf/0.8.13_1/include/libelf;/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk/usr/include/security;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/hphp;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/forks/libmbfl;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/forks/libmbfl/mbfl;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/forks/libmbfl/filters;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/fatal;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/libafdt/src/src;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/fastlz/src;$<TARGET_PROPERTY:onig,INTERFACE_INCLUDE_DIRECTORIES>;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/watchman/bundled_watchman-prefix/include;@@HOMEBREW_PREFIX@@/include/glib-2.0;@@HOMEBREW_PREFIX@@/lib/glib-2.0/include;@@HOMEBREW_PREFIX@@/include/freetype2;@@HOMEBREW_CELLAR@@/imagemagick@6/6.9.12-52/include/ImageMagick-6;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/folly/bundled_folly-prefix/include;/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/third-party/folly/include")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/CMake" "/tmp/hhvm-4.162-20220606-24161-4x576i/hhvm-4.162.0/hphp/public_tld/CMake"
    ${CMAKE_MODULE_PATH})
else()
  set(HHVM_INCLUDE_DIRS "@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include;/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk/usr/include;@@HOMEBREW_PREFIX@@/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/sqlite/include;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/tbb@2020/include;@@HOMEBREW_PREFIX@@/opt/openssl@1.1/include;@@HOMEBREW_CELLAR@@/dwarfutils/0.4.0/include/libdwarf-0;@@HOMEBREW_CELLAR@@/libelf/0.8.13_1/include/libelf;/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk/usr/include/security;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/forks/libmbfl;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/forks/libmbfl/mbfl;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/forks/libmbfl/filters;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/fatal;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/libafdt/src/src;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/fastlz/src;$<TARGET_PROPERTY:onig,INTERFACE_INCLUDE_DIRECTORIES>;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/watchman/bundled_watchman-prefix/include;@@HOMEBREW_PREFIX@@/include/glib-2.0;@@HOMEBREW_PREFIX@@/lib/glib-2.0/include;@@HOMEBREW_PREFIX@@/include/freetype2;@@HOMEBREW_CELLAR@@/imagemagick@6/6.9.12-52/include/ImageMagick-6;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/folly/bundled_folly-prefix/include;@@HOMEBREW_CELLAR@@/hhvm-4.162/4.162.0/include/hphp/third-party/folly/include")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_INSTALL_FULL_LIBDIR}/hhvm/CMake"
    ${CMAKE_MODULE_PATH})
endif()

message(STATUS "Configuring for HHVM API version ${HHVM_VERSION_BRANCH}")

include(HPHPFunctions)
include(HPHPIZEFunctions)
include(HPHPCompiler)
include(config)

foreach (dir ${HHVM_INCLUDE_DIRS})
  include_directories(${dir})
endforeach()

add_definitions("-DHHVM_BUILD_DSO")
foreach (def ${HHVM_DEFINITIONS})
  add_definitions("-D${def}")
endforeach()

add_custom_target(test COMMAND
                       HHVM_BIN=${CMAKE_INSTALL_FULL_BINDIR}/hhvm
                       ${CMAKE_CURRENT_SOURCE_DIR}/run-test
                       -a "-vDynamicExtensions.99=${EXTENSION_NAME}.so" test
                       DEPENDS ${EXTENSION_NAME})
